/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package com.marcofabbian.transaction.avroschema;

import org.apache.avro.generic.GenericArray;
import org.apache.avro.specific.SpecificData;
import org.apache.avro.util.Utf8;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

@org.apache.avro.specific.AvroGenerated
public class Account extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = -175383248849156262L;


  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Account\",\"namespace\":\"com.marcofabbian.transaction.avroschema\",\"fields\":[{\"name\":\"actor\",\"type\":{\"type\":\"enum\",\"name\":\"Actor\",\"symbols\":[\"BUYER\",\"SELLER\"]},\"doc\":\"Actor for the account\"},{\"name\":\"accountId\",\"type\":\"string\",\"doc\":\"Account identifier\"},{\"name\":\"accountCurrency\",\"type\":\"string\",\"doc\":\"Account currency\"},{\"name\":\"accountType\",\"type\":\"string\",\"doc\":\"Account type : Cash account, custody account and block chain wallet\"},{\"name\":\"accountUsage\",\"type\":{\"type\":\"enum\",\"name\":\"AccountUsage\",\"symbols\":[\"CREDIT\",\"DEBIT\"]},\"doc\":\"Account usage in the transaction\"}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static final SpecificData MODEL$ = new SpecificData();

  private static final BinaryMessageEncoder<Account> ENCODER =
      new BinaryMessageEncoder<>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<Account> DECODER =
      new BinaryMessageDecoder<>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<Account> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<Account> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<Account> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this Account to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a Account from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a Account instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static Account fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

  /** Actor for the account */
  private com.marcofabbian.transaction.avroschema.Actor actor;
  /** Account identifier */
  private java.lang.CharSequence accountId;
  /** Account currency */
  private java.lang.CharSequence accountCurrency;
  /** Account type : Cash account, custody account and block chain wallet */
  private java.lang.CharSequence accountType;
  /** Account usage in the transaction */
  private com.marcofabbian.transaction.avroschema.AccountUsage accountUsage;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public Account() {}

  /**
   * All-args constructor.
   * @param actor Actor for the account
   * @param accountId Account identifier
   * @param accountCurrency Account currency
   * @param accountType Account type : Cash account, custody account and block chain wallet
   * @param accountUsage Account usage in the transaction
   */
  public Account(com.marcofabbian.transaction.avroschema.Actor actor, java.lang.CharSequence accountId, java.lang.CharSequence accountCurrency, java.lang.CharSequence accountType, com.marcofabbian.transaction.avroschema.AccountUsage accountUsage) {
    this.actor = actor;
    this.accountId = accountId;
    this.accountCurrency = accountCurrency;
    this.accountType = accountType;
    this.accountUsage = accountUsage;
  }

  @Override
  public org.apache.avro.specific.SpecificData getSpecificData() { return MODEL$; }

  @Override
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }

  // Used by DatumWriter.  Applications should not call.
  @Override
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return actor;
    case 1: return accountId;
    case 2: return accountCurrency;
    case 3: return accountType;
    case 4: return accountUsage;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  // Used by DatumReader.  Applications should not call.
  @Override
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: actor = (com.marcofabbian.transaction.avroschema.Actor)value$; break;
    case 1: accountId = (java.lang.CharSequence)value$; break;
    case 2: accountCurrency = (java.lang.CharSequence)value$; break;
    case 3: accountType = (java.lang.CharSequence)value$; break;
    case 4: accountUsage = (com.marcofabbian.transaction.avroschema.AccountUsage)value$; break;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  /**
   * Gets the value of the 'actor' field.
   * @return Actor for the account
   */
  public com.marcofabbian.transaction.avroschema.Actor getActor() {
    return actor;
  }


  /**
   * Sets the value of the 'actor' field.
   * Actor for the account
   * @param value the value to set.
   */
  public void setActor(com.marcofabbian.transaction.avroschema.Actor value) {
    this.actor = value;
  }

  /**
   * Gets the value of the 'accountId' field.
   * @return Account identifier
   */
  public java.lang.CharSequence getAccountId() {
    return accountId;
  }


  /**
   * Sets the value of the 'accountId' field.
   * Account identifier
   * @param value the value to set.
   */
  public void setAccountId(java.lang.CharSequence value) {
    this.accountId = value;
  }

  /**
   * Gets the value of the 'accountCurrency' field.
   * @return Account currency
   */
  public java.lang.CharSequence getAccountCurrency() {
    return accountCurrency;
  }


  /**
   * Sets the value of the 'accountCurrency' field.
   * Account currency
   * @param value the value to set.
   */
  public void setAccountCurrency(java.lang.CharSequence value) {
    this.accountCurrency = value;
  }

  /**
   * Gets the value of the 'accountType' field.
   * @return Account type : Cash account, custody account and block chain wallet
   */
  public java.lang.CharSequence getAccountType() {
    return accountType;
  }


  /**
   * Sets the value of the 'accountType' field.
   * Account type : Cash account, custody account and block chain wallet
   * @param value the value to set.
   */
  public void setAccountType(java.lang.CharSequence value) {
    this.accountType = value;
  }

  /**
   * Gets the value of the 'accountUsage' field.
   * @return Account usage in the transaction
   */
  public com.marcofabbian.transaction.avroschema.AccountUsage getAccountUsage() {
    return accountUsage;
  }


  /**
   * Sets the value of the 'accountUsage' field.
   * Account usage in the transaction
   * @param value the value to set.
   */
  public void setAccountUsage(com.marcofabbian.transaction.avroschema.AccountUsage value) {
    this.accountUsage = value;
  }

  /**
   * Creates a new Account RecordBuilder.
   * @return A new Account RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Account.Builder newBuilder() {
    return new com.marcofabbian.transaction.avroschema.Account.Builder();
  }

  /**
   * Creates a new Account RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new Account RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Account.Builder newBuilder(com.marcofabbian.transaction.avroschema.Account.Builder other) {
    if (other == null) {
      return new com.marcofabbian.transaction.avroschema.Account.Builder();
    } else {
      return new com.marcofabbian.transaction.avroschema.Account.Builder(other);
    }
  }

  /**
   * Creates a new Account RecordBuilder by copying an existing Account instance.
   * @param other The existing instance to copy.
   * @return A new Account RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Account.Builder newBuilder(com.marcofabbian.transaction.avroschema.Account other) {
    if (other == null) {
      return new com.marcofabbian.transaction.avroschema.Account.Builder();
    } else {
      return new com.marcofabbian.transaction.avroschema.Account.Builder(other);
    }
  }

  /**
   * RecordBuilder for Account instances.
   */
  @org.apache.avro.specific.AvroGenerated
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Account>
    implements org.apache.avro.data.RecordBuilder<Account> {

    /** Actor for the account */
    private com.marcofabbian.transaction.avroschema.Actor actor;
    /** Account identifier */
    private java.lang.CharSequence accountId;
    /** Account currency */
    private java.lang.CharSequence accountCurrency;
    /** Account type : Cash account, custody account and block chain wallet */
    private java.lang.CharSequence accountType;
    /** Account usage in the transaction */
    private com.marcofabbian.transaction.avroschema.AccountUsage accountUsage;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$, MODEL$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(com.marcofabbian.transaction.avroschema.Account.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.actor)) {
        this.actor = data().deepCopy(fields()[0].schema(), other.actor);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
      if (isValidValue(fields()[1], other.accountId)) {
        this.accountId = data().deepCopy(fields()[1].schema(), other.accountId);
        fieldSetFlags()[1] = other.fieldSetFlags()[1];
      }
      if (isValidValue(fields()[2], other.accountCurrency)) {
        this.accountCurrency = data().deepCopy(fields()[2].schema(), other.accountCurrency);
        fieldSetFlags()[2] = other.fieldSetFlags()[2];
      }
      if (isValidValue(fields()[3], other.accountType)) {
        this.accountType = data().deepCopy(fields()[3].schema(), other.accountType);
        fieldSetFlags()[3] = other.fieldSetFlags()[3];
      }
      if (isValidValue(fields()[4], other.accountUsage)) {
        this.accountUsage = data().deepCopy(fields()[4].schema(), other.accountUsage);
        fieldSetFlags()[4] = other.fieldSetFlags()[4];
      }
    }

    /**
     * Creates a Builder by copying an existing Account instance
     * @param other The existing instance to copy.
     */
    private Builder(com.marcofabbian.transaction.avroschema.Account other) {
      super(SCHEMA$, MODEL$);
      if (isValidValue(fields()[0], other.actor)) {
        this.actor = data().deepCopy(fields()[0].schema(), other.actor);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.accountId)) {
        this.accountId = data().deepCopy(fields()[1].schema(), other.accountId);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.accountCurrency)) {
        this.accountCurrency = data().deepCopy(fields()[2].schema(), other.accountCurrency);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.accountType)) {
        this.accountType = data().deepCopy(fields()[3].schema(), other.accountType);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.accountUsage)) {
        this.accountUsage = data().deepCopy(fields()[4].schema(), other.accountUsage);
        fieldSetFlags()[4] = true;
      }
    }

    /**
      * Gets the value of the 'actor' field.
      * Actor for the account
      * @return The value.
      */
    public com.marcofabbian.transaction.avroschema.Actor getActor() {
      return actor;
    }


    /**
      * Sets the value of the 'actor' field.
      * Actor for the account
      * @param value The value of 'actor'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder setActor(com.marcofabbian.transaction.avroschema.Actor value) {
      validate(fields()[0], value);
      this.actor = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'actor' field has been set.
      * Actor for the account
      * @return True if the 'actor' field has been set, false otherwise.
      */
    public boolean hasActor() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'actor' field.
      * Actor for the account
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder clearActor() {
      actor = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'accountId' field.
      * Account identifier
      * @return The value.
      */
    public java.lang.CharSequence getAccountId() {
      return accountId;
    }


    /**
      * Sets the value of the 'accountId' field.
      * Account identifier
      * @param value The value of 'accountId'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder setAccountId(java.lang.CharSequence value) {
      validate(fields()[1], value);
      this.accountId = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'accountId' field has been set.
      * Account identifier
      * @return True if the 'accountId' field has been set, false otherwise.
      */
    public boolean hasAccountId() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'accountId' field.
      * Account identifier
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder clearAccountId() {
      accountId = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'accountCurrency' field.
      * Account currency
      * @return The value.
      */
    public java.lang.CharSequence getAccountCurrency() {
      return accountCurrency;
    }


    /**
      * Sets the value of the 'accountCurrency' field.
      * Account currency
      * @param value The value of 'accountCurrency'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder setAccountCurrency(java.lang.CharSequence value) {
      validate(fields()[2], value);
      this.accountCurrency = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'accountCurrency' field has been set.
      * Account currency
      * @return True if the 'accountCurrency' field has been set, false otherwise.
      */
    public boolean hasAccountCurrency() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'accountCurrency' field.
      * Account currency
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder clearAccountCurrency() {
      accountCurrency = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'accountType' field.
      * Account type : Cash account, custody account and block chain wallet
      * @return The value.
      */
    public java.lang.CharSequence getAccountType() {
      return accountType;
    }


    /**
      * Sets the value of the 'accountType' field.
      * Account type : Cash account, custody account and block chain wallet
      * @param value The value of 'accountType'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder setAccountType(java.lang.CharSequence value) {
      validate(fields()[3], value);
      this.accountType = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'accountType' field has been set.
      * Account type : Cash account, custody account and block chain wallet
      * @return True if the 'accountType' field has been set, false otherwise.
      */
    public boolean hasAccountType() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'accountType' field.
      * Account type : Cash account, custody account and block chain wallet
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder clearAccountType() {
      accountType = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'accountUsage' field.
      * Account usage in the transaction
      * @return The value.
      */
    public com.marcofabbian.transaction.avroschema.AccountUsage getAccountUsage() {
      return accountUsage;
    }


    /**
      * Sets the value of the 'accountUsage' field.
      * Account usage in the transaction
      * @param value The value of 'accountUsage'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder setAccountUsage(com.marcofabbian.transaction.avroschema.AccountUsage value) {
      validate(fields()[4], value);
      this.accountUsage = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'accountUsage' field has been set.
      * Account usage in the transaction
      * @return True if the 'accountUsage' field has been set, false otherwise.
      */
    public boolean hasAccountUsage() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'accountUsage' field.
      * Account usage in the transaction
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Account.Builder clearAccountUsage() {
      accountUsage = null;
      fieldSetFlags()[4] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public Account build() {
      try {
        Account record = new Account();
        record.actor = fieldSetFlags()[0] ? this.actor : (com.marcofabbian.transaction.avroschema.Actor) defaultValue(fields()[0]);
        record.accountId = fieldSetFlags()[1] ? this.accountId : (java.lang.CharSequence) defaultValue(fields()[1]);
        record.accountCurrency = fieldSetFlags()[2] ? this.accountCurrency : (java.lang.CharSequence) defaultValue(fields()[2]);
        record.accountType = fieldSetFlags()[3] ? this.accountType : (java.lang.CharSequence) defaultValue(fields()[3]);
        record.accountUsage = fieldSetFlags()[4] ? this.accountUsage : (com.marcofabbian.transaction.avroschema.AccountUsage) defaultValue(fields()[4]);
        return record;
      } catch (org.apache.avro.AvroMissingFieldException e) {
        throw e;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<Account>
    WRITER$ = (org.apache.avro.io.DatumWriter<Account>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<Account>
    READER$ = (org.apache.avro.io.DatumReader<Account>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

  @Override protected boolean hasCustomCoders() { return true; }

  @Override public void customEncode(org.apache.avro.io.Encoder out)
    throws java.io.IOException
  {
    out.writeEnum(this.actor.ordinal());

    out.writeString(this.accountId);

    out.writeString(this.accountCurrency);

    out.writeString(this.accountType);

    out.writeEnum(this.accountUsage.ordinal());

  }

  @Override public void customDecode(org.apache.avro.io.ResolvingDecoder in)
    throws java.io.IOException
  {
    org.apache.avro.Schema.Field[] fieldOrder = in.readFieldOrderIfDiff();
    if (fieldOrder == null) {
      this.actor = com.marcofabbian.transaction.avroschema.Actor.values()[in.readEnum()];

      this.accountId = in.readString(this.accountId instanceof Utf8 ? (Utf8)this.accountId : null);

      this.accountCurrency = in.readString(this.accountCurrency instanceof Utf8 ? (Utf8)this.accountCurrency : null);

      this.accountType = in.readString(this.accountType instanceof Utf8 ? (Utf8)this.accountType : null);

      this.accountUsage = com.marcofabbian.transaction.avroschema.AccountUsage.values()[in.readEnum()];

    } else {
      for (int i = 0; i < 5; i++) {
        switch (fieldOrder[i].pos()) {
        case 0:
          this.actor = com.marcofabbian.transaction.avroschema.Actor.values()[in.readEnum()];
          break;

        case 1:
          this.accountId = in.readString(this.accountId instanceof Utf8 ? (Utf8)this.accountId : null);
          break;

        case 2:
          this.accountCurrency = in.readString(this.accountCurrency instanceof Utf8 ? (Utf8)this.accountCurrency : null);
          break;

        case 3:
          this.accountType = in.readString(this.accountType instanceof Utf8 ? (Utf8)this.accountType : null);
          break;

        case 4:
          this.accountUsage = com.marcofabbian.transaction.avroschema.AccountUsage.values()[in.readEnum()];
          break;

        default:
          throw new java.io.IOException("Corrupt ResolvingDecoder.");
        }
      }
    }
  }
}










